%define BUILD_CUSTOM 0
%define BUILD_BOOT 0
%define BUILD_SECURE_SMP 0
%define BUILD_SECURE_UP 0
%define BUILD_RSBAC_SMP 0
%define BUILD_RSBAC_UP 0
%define BUILD_SMP 0
%define BUILD_UP 1

# Build drm from XFree86 sources
%define BUILD_DRM 0
%define BUILD_DRM_SIS 0

# What experimental packages to be build
%define BUILD_HACK_ALSA 0

# What kernel-related packages to be built.
%define BUILD_HEADERS 1
%define BUILD_SOURCE 1
%define BUILD_DOCS 0

# Custom kernel parameters.
%define CUSTOM custom
%define BUILD_CUSTOM_PCMCIA 0
%define BUILD_CUSTOM_ALSA 0
%define BUILD_CUSTOM_DRM 0
%define BUILD_CUSTOM_DXR2 0

# Choose the compiler
%define USE_GCC_COMPAT 0

%define sublevel 12
%define kversion 2.4.%sublevel

Name: kernel24
Version: %kversion
Release: alt1_w4l

%define acver %kversion-ac3
%define ovver 1.43
%define emuver 20011019
%define dxr2ver 20010613
%define dxr3ver 0.8.2
%define srcversion 2.4.12
%define pcmciaver 3.1.29
%define pcmciasource 04-Mar-01
%define ipvsver 0.8.1
%define alsaver 0.5.11
%define hackalsaver 0.9.0beta8a
%define acpiver 20001115
%define lmver 2.6.1
%define i2cver 2.6.1
%define KVERREL %kversion-%release
%define ipsecver 1.91
%define rsbacver 1.1.2-pre9
%define rsbacbugfixver 0
%define lircver 0.6.4
%define drmver 4.1.0
%define samver 1.0.0

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: System/Kernel and hardware
ExclusiveArch: %ix86
ExclusiveOS: Linux

%if %USE_GCC_COMPAT
BuildPreReq: dev86 compat-gcc db1-devel db3-devel byacc perl flex
%else
BuildPreReq: dev86 gcc db1-devel db3-devel byacc perl flex
%endif

###############
### SOURCES ###
###############

Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-%srcversion.tar.bz2
Source1: anonymous@projects.sourceforge.net:/pub/pcmcia-cs/pcmcia-cs-%pcmciaver.tar.bz2
Source4: README.kernel-sources
Source6: ftp://opensource.creative.com/pub/snapshots/emu10k1-%emuver.tar.bz2
Source7: ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%alsaver.tar.bz2
Source8: ftp://download.intel.com/technology/iapc/acpi/downloads/acpica-linux-%acpiver.tar.bz2
Source9: http://www.lm-sensors.nu/archive/lm_sensors-%lmver.tar.bz2
Source10: ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%hackalsaver.tar.bz2
Source11: http://download.sourceforge.net/LIRC/lirc-%lircver.tar.bz2
Source12: drm-%drmver.tar.bz2

Source13: rhkmvtag.c
Source14: sermouse.tar.bz2
Source15: dxr2-%dxr2ver.tar.bz2
Source16: i2c-%i2cver.tar.bz2

Source17: rsbac-v%rsbacver.tar.bz2
Source18: ipvs-%ipvsver.tar.bz2
Source19: freeswan-%ipsecver.tar.bz2

Source20: kernel-%kversion-i586-up.config
Source21: kernel-%kversion-i586-smp.config
Source22: kernel-%kversion-i686-up.config
Source23: kernel-%kversion-i686-smp.config
Source24: kernel-%kversion-athlon-up.config
Source25: kernel-%kversion-athlon-smp.config
Source26: kernel-%kversion-k6-up.config

Source30: kernel-%kversion-i586-up-rsbac.config
Source31: kernel-%kversion-i586-smp-rsbac.config
Source32: kernel-%kversion-i686-up-rsbac.config
Source33: kernel-%kversion-i686-smp-rsbac.config
Source34: kernel-%kversion-athlon-up-rsbac.config
Source35: kernel-%kversion-athlon-smp-rsbac.config
Source36: kernel-%kversion-k6-up-rsbac.config

Source41: kernel.xpm
Source42: kernel-source.menu

Source43: linux_logo.h.bz2

Source44: notes.2412.bz2

Source45: aa_patches.tar.bz2

Source50: 3rdparty-e100-1.6.5.tar.bz2
Source51: 3rdparty-e1000-3.0.10.tar.bz2
Source52: ov511-%ovver.tar.bz2
#Source53: sbni501-24.tar.bz2
Source54: em8300-%dxr3ver.tar.bz2
Source55: qla1x160src-3.23Beta.tar.bz2
Source56: qla2x00src-v4.31.8.tar.bz2
Source57: bttv-0.7.83-btaudio.c.bz2
Source58: qce-ga-cvs.tar.bz2
Source59: sam9407-%samver.tar.bz2
Source60: i810fb-1.1.1b.tar.bz2
Source61: siemens_dvb-0.9.3.tar.bz2
Source62: sam9407-kconfig.h
Source63: radeonfb-0.1.0-ve.1.tar.bz2

###############
### PATCHES ###
###############

###
# Kernel version updates and -ac patches.
# 0..99 #
###

Patch0: ftp://ftp.kernel.org/pub/linux/kernel/people/alan/2.4/patch-%acver.bz2

# Add Crypto IP Encapsulation
Patch10: linux-2.4.2-ac28-cipe-1.4.5.patch.bz2
Patch11: linux-2.4.2-ac28-cipefix.patch
# Sparc support is currently broken

# Fix headers to don't be pollute when #include from user space tool
Patch12: kernel-2.4-string.patch.bz2

# Fix sparc vga
Patch14: linux-2.3.99p3p6-sparc.patch

# USEIO in eepro driver
Patch15: linux-2.2.16-useio.patch

# PCMCIA patches
Patch155: linux-2.2.18-pcmcia-Configure.ipl.patch
Patch156: linux-2.2.18-pcmcia-makefile.ipl.patch

###### Mandrake: (begin from 200) #################################
Patch200: linux-2.4.10-ac10-iscsi-update.patch.bz2

# Fix ide cd
Patch201: linux-2.4.5-ac5-ide-cd-fix.patch

# Freeswan patch
Patch202: freeswan-1.91-fix-debug.patch

# Keyboard silence patch
Patch203: linux-2.4.3-ac13-keyboardsilence.patch

# DRM silence patch
Patch204: linux-2.4.3-ac4-drm-silence.patch

# Fix mounting usbdevfs with owner and gid number
Patch210: linux-2.4.3-ac4-usbdevfs-fix-mount-owner-gid.patch

# Add ppptoe-pptoa patch for modem over ATM
#Patch213: linux-2.4.4-ac10-ppptoe-ppptoa.patch.bz2

# Add USB message throttling
#Patch214: linux-2.4.4-ac10-usbthrottle.patch

# make scanning of sparselun devices work again
#Patch215: linux-2.4.3-ac4-scsi_scan.patch

# Fix PSAUX Waiting for port.
Patch218: linux-2.4.3-ac3-psaux-keyboard-wait.patch

# Support for isdn olitec cards
Patch220: linux-2.4.3-isdn-olitec-gazel.patch

# Update wacom.c from Fred Lepied.
#Patch221: linux-2.4.4-ac15-wacom-update.patch.bz2

# Add IRC netfilter addon.
Patch222: linux-2.4.5-ac5-netfilter-addons.patch.bz2

# Add alternate airo devices drivers
Patch226: linux-2.4.2-ac20-alternateairo.patch.bz2

# Don't printk when     polling CDROMs for disk change
Patch227: linux-2.4.2-ac20-quiet-cdrom.patch

# Alcatel Speedtouch patch
Patch228: linux-2.4.9-ac3-speedtouch.patch.bz2

# Add USBVision
Patch230: linux-2.4.12-ac3-usbvision.patch.bz2

# DevFS patches
#Patch231: linux-2.4.8-ac9-devfs-revert.patch
#Patch232: devfs-patch-v193.bz2

#Patch233: linux-2.4.8-ac9-devfslatest-with-scsimon-fixes.patch
#Patch234: linux-2.4.8-ac7-xircom-pgsdb9.patch.bz2
Patch235: linux-2.4.8-ac7-triplelock.patch
Patch236: linux-2.4.8-ac7-sym53c8xx-fixes.patch
Patch237: linux-2.4.8-ac7-scsitimeout.patch
Patch238: linux-2.4.8-ac7-pdcraid.patch
Patch239: linux-2.4.8-ac7-oomavoidance.patch
Patch240: linux-2.4.8-ac7-numargs.patch
Patch241: linux-2.4.8-ac7-keyboardsilence.patch
Patch242: linux-2.4.8-ac7-ioqueue.patch
#Patch243: linux-2.4.8-ac7-ext3-debug.patch
Patch244: linux-2.4.8-ac7-ethtool.patch
Patch245: linux-2.4.10-ac4-cramfs.patch
Patch246: linux-2.4.8-ac3-sb_id.patch
Patch247: linux-2.4.8-ac3-parportpnp.patch
Patch248: linux-2.4.8-ac3-iscsi.patch.bz2
Patch249: linux-2.4.8-ac3-apic-quiet.patch
Patch250: linux-2.4.8-ac2-nec-picty900-printer.patch
Patch251: linux-2.4.8-ac2-atm-fixes.patch
Patch252: linux-2.4.8-ac1-speedtouch-fixes.patch
Patch253: linux-2.4.10-ac4-lanstreamer-update.patch
Patch254: linux-2.4.8-ac12-fix-parent-reclaim.patch
#Patch255: linux-2.4.9-ac10-firewire-update.patch.bz2
Patch256: linux-2.4.8-ac12-emu10k1-mmap-fixes.patch
Patch257: linux-2.4.8-ac12-devfs-dynamic-disk.patch
Patch258: linux-2.4.8-ac12-wacom-update.patch
Patch259: linux-2.4.10-ac10-ide-floppy-devfs.patch
#Patch260: linux-2.4.8-ac12-ext3-abort.patch.bz2

###### ALT LINUX: (begin from 300) #################################

Patch300: linux-2.4.5-ac3-reiserfs.quota.patch.bz2
Patch301: linux-2.4.5-ac5-reiserfs-umount-fix.patch
#Patch302: linux-2.4.9-ac10-lanai.patch.bz2
Patch303: linux-2.4.9-ac3-agp_newchips.patch
Patch304: linux-2.4.9-ac5-qla1280.patch
Patch305: alsa-gcc296.patch.bz2
Patch306: linux-2.4.3-ac14-fbcon.patch
Patch307: linux-2.4.7-ac1-maxi_radio.patch
Patch308: ide.2.4.5-ac9.all.06062001.patch.bz2
Patch309: ide.2.4.5-p1.tfio2.05132001.patch.bz2
Patch310: linux-2.4.9-ac10-shutup.patch.bz2
Patch311: linux-2.2.17-init.ipl.patch
Patch312: linux-2.4.12-ac3-i810-printk.patch
Patch313: linux-2.4.1-radeon.ipl.patch
Patch314: linux-2.4.1-server-tuning.ipl.patch
Patch316: linux-2.4.8-ac1-sf16fmx2.patch
Patch317: patch-int-2.4.7-alt.bz2

# IPSEC: add config generated with make patches from the freeswan sources.
Patch318: linux-2.4.1-ipsec-config-snap.patch
Patch319: linux-2.2.18-fix-ipsec-include.patch

Patch320: linux-2.4.10-ac4-ipvs-ksyms_c.patch
Patch321: linux-2.4.8-ac8-via82cxxx.patch
# http://bytesex.org/bttv
Patch322: bttv-0.7.83-2.4.13-pre2.diff.bz2
Patch323: linux-2.4.9-ac3-emu10k1.patch
#Patch324: acpi-13072001.diff.bz2
Patch325: linux-2.4.2-netlink.patch
#Patch326: linux-2.4.5-ac13-i810_audio.patch
Patch327: linux-2.4.2-pfkey.patch
Patch328: linux-2.4.2-pcmcia_aic.patch
Patch329: linux-2.4.3-ac7-aic7xxx.patch
Patch330: linux-2.4.3-ac3-pckeyb.patch
Patch331: linux-2.4.4-ac10-promise.patch
#Patch332: btaudio-2.4.10-pre9.diff.bz2
Patch333: linux-2.4.4-ac17-proc.patch
Patch334: linux-2.4.9-ac3-lirc.patch
Patch335: drm-Makefile.patch
Patch336: linux-2.4.9-ac5-qla2x00_conf.patch
Patch337: linux-2.4.6-ac1-via82cxxx.patch.bz2
Patch338: linux-2.4.7-ac9-nand.patch
Patch339: linux-2.4.10-ac4-maestro_multiopen.patch.bz2

# dc395 updates: http://www.garloff.de/kurt/linux/dc395/
Patch340: linux-2.4.5-ac6-dc395.patch.bz2

# dpt support.
#Patch341: linux-2.4.5-ac15-dpt_i2o-2.3-build8-patch.bz2

# Add upgrade of nfs for 2.4.0
#Patch342: linux-2.4.10-ac4-ping.patch.bz2

# Add ide-floppy upgrade
Patch343: linux-2.4.7-ac1-ide-floppy.patch.bz2

# Upgrade IPS to 4.50.
#Patch344: linux-2.4.1-ac3-ips-4.50.patch.bz2

# Upgrade megaraid to 1.14a.
#Patch346: linux-2.4.1-ac3-megaraid-1.14a.patch.bz2; in kernel now

# 3c90x drivers
Patch349: linux-2.4.1-ac4-3c90x.patch.bz2

# e820 (ACPI) support
Patch351: linux-2.4.1-ac4-e820.patch

# For the two patches e100 and e1000
Patch352: linux-2.4.12-ac3-intelethernet-Makefile.patch

# Fix IRDA assertion
#Patch353: linux-2.4.1-ac4-irda-assert.patch.bz2

# Fix assertion of kiobuf to map to user
#Patch354: linux-2.4.1-ac4-map_user_kiobuf-fix.patch.bz2

# Fix all warning that users can show
Patch355: linux-2.4.1-ac4-fix-warning.patch

# Raid5xor
Patch356: linux-2.4.1-ac4-raid5xor.patch

# Sard Patch
Patch357: linux-2.4.1-ac4-sard.patch.bz2

# Accraid support
Patch358: linux-2.4.10-ac4-aacraid.patch.bz2

# Fix bad udelay with wavelan
Patch359: linux-2.4.1-ac4-wavelan-udelay.patch

# Alternate Lucent Wavelan wireless support
Patch360: linux-2.4.6-ac1-wvlan-cs.patch.bz2

# Fix aacraid compilation
#Patch362: linux-2.4.1-ac4-fix-pcmcia-scsi.patch.bz2

# Remove perm.h include file from isadump.c (alpha)
Patch399: linux-2.4.1-ac8-lmsensors_alpha.patch

## New NFS patches from Neil Brown:

# Relax nfs export rules for exporting children and parents
# Without this patch you cannot export a parent and a child
# on the same filesystem.
# With this patch you can as long as the parent has more restrictive
# options and the child does not have no_subtree_check
Patch450: linux-2.4.2-ac28-nfsexp.patch

# Change args of md_error to be mddev_t instead of kdev_t
# All callers of  md_error have an mddev_t, and that is what
# md_error really wants, so we nolonger convert to kdev_t and back.
Patch451: linux-2.4.2-ac28-mderror.patch

# Use sector number of b_blocknr is raid1 bufferes.
# This allows raid1 not to be confused if given a
# non-aligned IO request. (will be needed for partitioning)
Patch453: linux-2.4.2-ac28-r1blocknr.patch

# Bypass stripe cache for reads
# Previously, reads on a raid5 array would read into the stripe cache,
# and then copy into the buffer.  This appears to limit sequential
# read speed.
# This patch bypasses the copy for read, at the cost of possibly having to
# read the data again if it is needed for parity calculations.
#Patch454: linux-2.4.2-ac28-raid5readbypass.patch

# Second version of raid5 plugging.  Untested
Patch455: linux-2.4.2-ac28-r5plug.patch

# Make sure all raid5 IO requests are properly aligned.
# XFS, and LVM can make non-aligned requests (I think).
# These do not work with raid5 :-)
# This patch generates early warnings of problems.
Patch456: linux-2.4.2-ac28-r5align.patch

# Provide an "nfsd_operations" interface between knfsd and
# each filesystem.
# With this patch, you will not be able to export any
# filesystem except ext2fs, but then you couldn't reliably before anyway.
# For more about nfs, see my LinuxKnfsd page.
#Patch457: linux-2.4.4-ac5-nfsdops.patch.bz2

# Add support for knfsd in reiserfs
# This is from Danilov Nikita, Chris Mason, and the reiserfs team
#Patch458: linux-2.4.4-ac3-reisernfs.patch.bz2

# isofs support for nfsd_operations
# This allows isofs to be exported with knfsd.  Support is incomplete,
# but it is a good as Linux has ever provided before.
# i.e. it works until directories start getting thown out of cache, either
# be mem pressure or by reboot.
#Patch459: linux-2.4.3-ac14-isofsnfs.patch.bz2

# knfsd support for ufs
# Make ufs compatabile with knfsd, adding get_parent routine,
# handling generation numbers, and disallowing iget on a deleted file.
#Patch460: linux-2.4.2-ac28-ufsnfs.patch.bz2

# nfsd support for efs
#Patch461: linux-2.4.2-ac28-efsnfs.patch.bz2

# Provide call trace in /proc/X/status
# This patch, for i386 only, add some lines to /proc/pid/status which shows a
# guess at the call trace for processes that are executing in the kernel.  This
# makes tracing deadlocks much easier.
Patch462: linux-2.4.2-ac28-calltrace.patch
# end neilb patches

# Quickcam logteck usb: http://qce-ga.sourceforge.net/
Patch475: linux-2.4.9-ac10-qce-ga.patch

# Check Overflow (security fixes).
#Patch501: linux-2.4.6-ac1-overflow.patch

# No debug for highmem.
#Patch502: linux-2.4.0-ac12-nohighmemdebug.patch

# Fix cpp output for netfilter drivers
#Patch503: linux-2.4.0-ac12-netfilter-cpp.patch

# http://homepages.paradise.net.nz/stevenel/tw98/index.html
Patch504: tw98_0.1.patch.bz2

# JFS patch
Patch550: linux-2.4.10-ac10-jfs-1.0.7-common.patch.bz2
Patch551: linux-2.4.10-ac10-jfs-1.0.7-shared.patch

# BCM5820 patches
Patch555: linux-2.4.7-ac7-bcm5820.patch.bz2
Patch556: linux-2.4.7-ac7-bcm5820-2.patch.bz2

# RAID Multipath patch
#Patch560: linux-2.4.9-ac10-multipath.patch.bz2
#Patch561: linux-2.4.2-ac20-multipath-export.patch
#Patch562: linux-2.4.6-ac1-multipath-fixes-2.patch
#Patch563: linux-2.4.6-ac1-multipath-md_error-fix.patch

# Supermount patches
Patch570: linux-2.4.8-ac12-supermount-0.7.5.patch.bz2

# SCSI monitor patch
Patch575: linux-2.4.10-ac4-scsimon-2.4.3-1.patch.bz2

Patch576: linux-2.4.7-ac2-fix-rebuild-aic7xx-firmware.patch

Patch578: linux-2.4.6-ac2-silicom-u2e.support.patch

Patch579: linux-2.4.6-ac2-du-e100.support.patch

# Mandrake patches fixed by ALT
Patch580: linux-2.4.12-ac3-xfs.patch.bz2
#Patch581: linux-2.4.12-ac3-core-xfs-09052001.patch.bz2

# IRDA fixes
#Patch585: linux-2.4.8-ac12-irda-usb-reorg.patch.bz2
#Patch586: linux-2.4.8-ac12-irda-disco-fixes.patch
#Patch587: linux-2.4.8-ac12-irda-irnet-nodelay.patch
#Patch588: linux-2.4.8-ac12-irda-hw-name.patch
#Patch589: linux-2.4.8-ac12-irda-lap-keepalive.patch
#Patch590: linux-2.4.8-ac12-irda-ias-fixes.patch
#Patch591: linux-2.4.8-ac12-irda-sk-free.patch

#Patch592: linux-2.4.9-ac10-pwc-8.2.patch.bz2
#Patch593: linux-2.4.8-ac12-usb-register-after-hiddev.patch
#Patch594: linux-2.4.8-ac12-radeon-fixes.patch
Patch595: linux-2.4.8-ac12-overflow.patch
#Patch596: linux-2.4.8-ac12-ntfs-fixes.patch.bz2
#Patch597: linux-2.4.8-ac12-nfsoops.patch
#Patch598: linux-2.4.8-ac12-nfs-reclaim.patch
#Patch599: linux-2.4.8-ac12-nfs-client-update.patch

# Other ALT Linux patches
Patch600: linux-2.4.5-ac13-dxr2.patch
Patch601: linux-2.4.5-ac15-lcap.patch
Patch602: linux-2.4.6-ac1-loop_lock.patch
Patch603: linux-2.4.6-ac1-promise_quircky.patch
Patch604: linux-2.4.9-ac3-emu_midi.patch
Patch605: linux-2.4.6-ac2-cryptoapi.patch
Patch606: linux-2.4.5-ac13-iforce.update.patch
Patch607: pcmcia-cs-3.1.27-ohci_update.patch
Patch608: linux-2.4.5-ac13-usbvision-device-map.patch
Patch609: linux-2.4.5-ac15-kaweth-fix.patch
Patch610: linux-2.4.7-ac5-bootlogo_with_version.patch
Patch611: linux-2.4.7-ac1-bcm5700.patch.bz2
Patch612: linux-2.4.6-ac1-ov511_make.patch
Patch613: linux-2.4.8-ac7-vlan-1.4.patch.bz2
Patch614: linux-2.4.6-iso9660opt.patch
Patch615: linux-2.4.10-ac4-dl2k.patch
Patch616: linux-2.4.7-ac2-pcmcia.patch
Patch617: linux-2.4.7-ac9-ext3.patch
Patch618: linux-2.4.7-ac3-viakt133.diff
Patch619: linux-2.4.5-ac13-i810-fixes.patch
Patch620: linux-2.4.7-ac3-dxr3.patch
Patch621: linux-2.4.8-ac1-dxr3_i2c.patch
Patch622: pcmcia-ibmtr_cs-fix.patch
Patch623: pcmcia-cs-3.1.27-spectrum-2.4t.patch.bz2
Patch624: sf16-mixer-1.0-2.2.14.patch
Patch625: linux-2.4.9-ac3-ixj.patch
Patch626: pcmcia-cs-3.1.29-8139too_cb.patch.bz2
Patch627: pcmcia-3.1.29-wvlan_fix.patch
Patch628: linux-2.4.9-ac5-ide-scsi.patch
Patch629: num_serial_ports.2.4.0108xx.010822.patch
Patch630: linux-2.4.8-ac2-cpus_allowed.patch
Patch631: linux-2.4.9-ac10-genesys.patch.bz2
Patch632: linux-2.4.12-ac3-qla1280.patch.bz2
Patch633: linux-2.4.12-ac3-iscsi_config.patch
Patch634: linux-2.4.9-ac10-sam9407.patch
Patch635: linux-2.4.10-ac4-ipt_string.patch
Patch636: linux-2.4.9-ac10-i81x.patch
Patch637: linux-2.4.12-ac3-dvb_conf.patch
Patch638: linux-2.4.10-ac12-jfs-fix-crashes.patch
Patch639: linux-2.4.9-ac10-strip.patch
Patch640: linux-2.4.10-ac4-namespace.patch
Patch641: linux-2.4.9-ac10-cipe_fix.patch
Patch642: pcmcia-cs-3.1.29-Spectrum24t.patch
Patch643: linux-2.4.10-ac4-mmx.patch
Patch644: linux-2.4.10-ac4-proxyarp.patch
Patch645: linux-2.4.10-ac7-gendisk.patch
Patch646: linux-2.4.12-ac3-compiler.patch

# RSBAC patches
Patch700: patch-%acver-v%rsbacver.bz2
%if %rsbacbugfixver
Patch701: rsbac-bugfix-v%rsbacver-%rsbacbugfixver.diff
%endif
Patch702: rsbac-ruid.patch
Patch703: linux-2.4.3-ac3-rsbac_debug.patch
Patch704: rsbac-log.patch
#- temporary removed !!!
Patch706: rsbac-rc-redirect-2.patch
#- temporary removed !!!
#Patch707: rsbac-rename-fix.patch
#Patch708: rsbac-rcsoftmode.patch

Patch800:  Kernel-Win4Lin3-2.4.12.patch
Patch801:  mki-adapter.patch

####################
### DESCRIPTIONS ###
####################

### KERNELS and MODULES ###

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

#
# kernel: normal kernel, framebuffer, no SMP, no OpenWall security
#

%package up
Summary: The Linux kernel (the core of the Linux operating system)
Group: System/Kernel and hardware

Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-fb = %kversion, kernel-up = %kversion
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4
Obsoletes: kernel-modules, kernel-sparc, kernel-fb

%description up
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

#
# kernel-smp: Symmetric MultiProcessing kernel
#
%package smp
Summary: The Linux Kernel compiled for SMP machines
Group: System/Kernel and hardware

Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-smp = %kversion, kernel-smp-fb = %kversion, kernel-smp = %kversion
Obsoletes: kernel-smp-fb
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4

%description smp
This package includes a SMP version of the Linux %kversion kernel. It is
required only on machines with two or more CPUs, although it should work
fine on single-CPU boxes.

#
# kernel-secure-smp: smp kernel with OpenWall patch
#
%package smp-secure
Summary: The secure version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-smp-secure = %kversion, kernel-smp-secure = %kversion
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4

%description smp-secure
The Secure-Linux patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

#
# kernel-secure-up: up kernel with OpenWall patch
#
%package up-secure
Summary: The secure version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-up-secure = %kversion, kernel-up-secure = %kversion
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4

%description up-secure
The Secure-Linux patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

#
# kernel-rsbac-smp: smp kernel with RSBAC patch
#
%package smp-rsbac
Summary: The rsbac version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-smp-rsbac = %kversion, kernel-smp-rsbac = %kversion
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4

%description smp-rsbac
RSBAC is a flexible, powerful and fast open source access control
framework for current Linux kernels, which has been in stable
production use for over a year (since version 1.0.9a).

#
# kernel-rsbac-up: up kernel with RSBAC patch
#
%package up-rsbac
Summary: The rsbac version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-up-rsbac = %kversion, kernel-up-rsbac = %kversion
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4

%description up-rsbac
RSBAC is a flexible, powerful and fast open source access control
framework for current Linux kernels, which has been in stable
production use for over a year (since version 1.0.9a).

#
# kernel-boot: kernel for installation
#
%package boot
Summary: The Linux Kernel compiled for linux installation
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-boot = %kversion, kernel-boot = %kversion
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4

%description boot
This package includes an installation version of the Linux %kversion kernel.

#
# kernel, customized by user.
#
%if %BUILD_CUSTOM
%package %CUSTOM
Summary: Custom kernel version %kversion for %CUSTOM box
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-%CUSTOM = %kversion
%ifarch %ix86
PreReq: /sbin/installkernel, /usr/sbin/rdev
%endif
Requires: modutils >= 2.4.10, mkinitrd >= 2.7.1-alt4

%description %CUSTOM
This package includes a custom version of the Linux %kversion kernel
designed for %CUSTOM box.
%endif

%package -n alsa24-up
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-up = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %alsaver

%description -n alsa24-up
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default up kernel.

%package -n alsa24-smp
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-smp = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %alsaver

%description -n alsa24-smp
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for smp kernel.

%package -n alsa24-smp-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-smp-secure = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %alsaver

%description -n alsa24-smp-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for secure smp kernel.

%package -n alsa24-up-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-up-secure = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %alsaver

%description -n alsa24-up-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for secure up kernel.

%package -n alsa24-smp-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-smp-rsbac = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %alsaver

%description -n alsa24-smp-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for rsbac smp kernel.

%package -n alsa24-up-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-up-rsbac = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %alsaver

%description -n alsa24-up-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for rsbac up kernel.

%if %BUILD_CUSTOM
%package -n alsa24-%CUSTOM
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-%CUSTOM = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %alsaver

%description -n alsa24-%CUSTOM
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for %CUSTOM kernel.
%endif

%package -n hackalsa24-up
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%hackalsaver
Requires: kernel24-up = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %hackalsaver
Conflicts: alsa24-up

%description -n hackalsa24-up
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default up kernel.

%package -n hackalsa24-smp
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%hackalsaver
Requires: kernel24-smp = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %hackalsaver
Conflicts: alsa24-smp

%description -n hackalsa24-smp
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for smp kernel.

%package -n hackalsa24-smp-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%hackalsaver
Requires: kernel24-smp-secure = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %hackalsaver
Conflicts: alsa24-smp-secure

%description -n hackalsa24-smp-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for secure smp kernel.

%package -n hackalsa24-up-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%hackalsaver
Requires: kernel24-up-secure = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %hackalsaver
Conflicts: alsa24-up-secure

%description -n hackalsa24-up-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for secure up kernel.

%package -n hackalsa24-smp-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%hackalsaver
Requires: kernel24-smp-rsbac = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %hackalsaver
Conflicts: alsa24-smp-rsbac

%description -n hackalsa24-smp-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for rsbac smp kernel.

%package -n hackalsa24-up-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%hackalsaver
Requires: kernel24-up-rsbac = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %hackalsaver
Conflicts: alsa24-up-rsbac

%description -n hackalsa24-up-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for rsbac up kernel.

%if %BUILD_CUSTOM
%package -n hackalsa24-%CUSTOM
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%hackalsaver
Requires: kernel24-%CUSTOM = %KVERREL
Obsoletes: alsa-driver
Provides: alsa = %hackalsaver
Conflicts: alsa24-%CUSTOM

%description -n hackalsa24-%CUSTOM
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for %CUSTOM kernel.
%endif

### SOURCES, HEADERS, DOCS ###

%package headers
Summary: Header files for the Linux kernel
Group: Development/Kernel
Requires: kernel-headers-common, initscripts >= 5.49-ipl10mdk
Prefix: %prefix
Obsoletes: kernel-headers
Provides: kernel-headers

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for building
most standard programs.  The header files are also needed for rebuilding
the kernel.

%package source
Summary: The source code for the Linux kernel
Group: Development/Kernel
Requires: glibc-devel, ncurses-devel, make, gcc, dev86, byacc, flex
Provides: kernel-source
PreReq: kernel-headers = %KVERREL
Obsoletes: alsa-source, kernel-source
AutoReq: no
Prefix: %prefix

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned to
your particular hardware, if you are so inclined (and you know what you're
doing).

%package -n alsa24-source
Summary: The Advanced Linux Sound Architecture (ALSA) source
Group: Development/Kernel
Version: %{kversion}_%alsaver
Requires: kernel-source = %KVERREL, glibc-devel, ncurses-devel, make, gcc, dev86
Provides: alsa-source
AutoReq: no
Prefix: %prefix

%description -n alsa24-source
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package is the source of alsa use it to fit your alsa modules to the
kernel.

%package -n drm-source
Summary: Direct Rendering Module (DRM) sources
Group: Development/Kernel
Version: %{kversion}_%drmver
Requires: kernel-source = %KVERREL, glibc-devel, ncurses-devel, make, gcc, dev86
AutoReq: no
Prefix: %prefix

%description -n drm-source
DRM drivers for 3D rendering in XFree86-4.x.

This package is the source of drm use it to fit your drm modules to the
kernel.

%package -n dxr2-source
Summary: Creative DXR2 driver sources
Group: Development/Kernel
Version: %{kversion}_%dxr2ver
Requires: kernel-source = %KVERREL, glibc-devel, ncurses-devel, make, gcc, dev86
AutoReq: no
Prefix: %prefix

%description -n dxr2-source
Creative DXR2 DVD card driver sources

This package is the source of dxr2 use it to fit your dxr2 modules to the
kernel.

%package -n hackalsa24-source
Summary: The Advanced Linux Sound Architecture (ALSA) source
Group: Development/Kernel
Version: %{kversion}_%hackalsaver
Requires: kernel-source = %KVERREL, glibc-devel, ncurses-devel, make, gcc, dev86
Provides: alsa-source, alsa24-source
AutoReq: no
Prefix: %prefix

%description -n hackalsa24-source
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package is the source of alsa use it to fit your alsa modules to the
kernel.

%package -n alsa-driver-headers
Summary: The Advanced Linux Sound Architecture (ALSA) header files
Group: Development/Kernel
Version: %hackalsaver
AutoReq: no
Prefix: %prefix

%description -n alsa-driver-headers
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package contains header files of alsa.

##########################
# Miscellaneous packages #
##########################

#
# kernel-doc: documentation for the Linux kernel
#
%package doc
Summary: Various documentation bits found in the kernel source
Group: Development/Kernel

%description doc
This package contains documentation files form the kernel source. Various
bits of information about the Linux kernel and the device drivers shipped
with it are documented in these files. You also might want install this
package if you need a reference to the options that can be passed to Linux
kernel modules at load time.

#
# End packages - here begins build stage
#

############
### PREP ###
############

%prep
### SOURCE ###

%setup -q -n linux -a1 -a6 -a7 -a9 -a10 -a17 -a18 -a19 -a11 -a12 -a14 -a15 -a16 -a50 -a51 -a45 -a52 -a54 -a58 -a59 -a60 -a61 -a63

# For patches.
ln -nsf pcmcia-cs-%pcmciaver pcmcia
ln -nsf alsa-driver-%alsaver alsa
ln -nsf ov511-%ovver ov511
ln -nsf em8300-%dxr3ver em8300
# Freeswan
ln -snf freeswan-%ipsecver freeswan
ln -snf ../freeswan-%ipsecver/klips/net/ipsec net/
ln -snf ../../../lib net/ipsec/libfreeswan
ln -snf ../../../zlib net/ipsec/
ln -snf ../../../libdes net/ipsec/
ln -snf Makefile.kernel net/ipsec/libfreeswan/Makefile
# DRM
ln -snf drm-%drmver drm

rm -rf pcmcia/{cardmgr,flash,debug-tools,man,etc,doc,PCMCIA-HOWTO}
rm -rf freeswan/{doc,pluto,utils}

# Install intelethernet drivers
install -p -m644 e100/*.{h,c} drivers/net
install -p -m644 e1000/*.{h,c} drivers/net

%patch0 -p1

# Temporary fix
rm -f drivers/ide/amd7409.c

# fix read-only permissions which break build
chmod -R +w pcmcia*

# Apply aa patches
for i in `/bin/ls aa_patches/*`; do
    echo "Applying patch $i"; echo
    patch -s -p1 <"$i"
done

%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch14 -p1
%patch15 -p1

chmod +x arch/sparc*/kernel/check_asm.sh

mkdir -p configs/
%ifarch %ix86
install -m644 %SOURCE20 configs/
%endif

%ifarch alpha
install -m644 %SOURCE21 configs/
%endif

# PCMCIA
%ifarch %ix86
cd pcmcia-cs-%pcmciaver
# Fix ibmtr_cs compile bug
rm -rf include/linux/ibmtr.h
%patch155 -p2
%patch156 -p2
%patch607 -p1
%patch622 -p1
%patch623 -p1
%patch626 -p1
%patch627 -p1
%patch642 -p1
cd ..
%else
rm -rf pcmcia-cs-%pcmciaver
%endif

#%patch200 -p1
%patch201 -p1
%patch202 -p0
%patch203 -p1
%patch204 -p1

%patch210 -p1
#%patch213 -p1
#%patch214 -p1
#%patch215 -p1
#%patch218 -p1
%patch220 -p1
%patch222 -p1
%patch226 -p1
%patch227 -p1
%patch228 -p1
%patch230 -p1

#%patch231 -p1
#%patch232 -p1
#%patch234 -p1
%patch235 -p1
%patch236 -p1
%patch237 -p1
%patch238 -p1
%patch239 -p1
%patch240 -p1
%patch241 -p1
%patch242 -p1
#%patch243 -p1
%patch244 -p1
%patch245 -p1
%patch246 -p1
%patch247 -p1
%patch248 -p1
%patch249 -p1
%patch250 -p1
%patch251 -p1
%patch252 -p1
%patch253 -p1
%patch254 -p1
#%patch255 -p1
%patch257 -p1
%patch258 -p1
%patch259 -p1
#%patch260 -p1

# Altlinux patches
#%patch300 -p1
%patch301 -p1
#%patch321 -p1
#%patch302 -p1
%patch303 -p1
%if !%USE_GCC_COMPAT
%patch305 -p1
%endif
%patch306 -p1
%patch307 -p1
#%patch308 -p1
#%patch309 -p1
%patch310 -p1
%patch311 -p1
%patch312 -p1
%patch313 -p1
%patch314 -p1
%patch316 -p1
%patch317 -p2
%patch318 -p1
%patch319 -p1

# IPVS patches
# Fix for ksyms patch
# cat ipvs-%ipvsver/linux_kernel_ksyms_c.diff | patch -p1
%patch320 -p1
cat ipvs-%ipvsver/linux_net_Makefile.diff | patch -p1
cat ipvs-%ipvsver/linux_net_ipv4_Config_in.diff | patch -p1
cat ipvs-%ipvsver/linux_ip_fw_compat_c.diff | patch -p1
cp -rp ipvs-%ipvsver/ipvs net/ipv4
mv net/ipv4/ipvs/linux_net_ipv4_ipvs_Makefile net/ipv4/ipvs/Makefile

# BTTV patches
%patch322 -p1

# Update btaudio driver
bzcat %SOURCE57 > drivers/sound/btaudio.c

#%patch324 -p1
%patch325 -p1
#%patch326 -p1
%patch327 -p1
%patch328 -p1
%patch329 -p1
%patch330 -p1
%patch331 -p1
%patch333 -p1
%patch335 -p1
%patch337 -p1
%patch338 -p1
%patch339 -p1

%patch340 -p1
#%patch341 -p1
#%patch342 -p1
#%patch343 -p1
#%patch344 -p1
#%patch346 -p1
#%patch347 -p1
%patch349 -p1
%patch351 -p1
%patch352 -p1
#%patch353 -p1
#%patch354 -p1
%patch356 -p1
#%patch357 -p1 #sard
%patch358 -p1
%patch359 -p1
%patch360 -p1

%ifarch alpha
%patch399 -p1
%endif

#neil brown series patches
%patch450 -p1
#%patch451 -p1
#%patch453 -p1
#%patch454 -p1
#%patch455 -p1
%patch456 -p1
#%patch457 -p1
#%patch458 -p1
#%patch459 -p1
#%patch460 -p1
#%patch461 -p1
%patch462 -p1


#%patch500 -p1
#%patch501 -p1
#%patch502 -p1
#%patch503 -p1
%patch504 -p1

cp -f dxr2/makefile dxr2/makefile_old

# JFS patches
%patch550 -p1
%patch551 -p1

%patch555 -p1
%patch556 -p1
#%patch560 -p1
#%patch561 -p1
#%patch562 -p1
#%patch563 -p1

# Supermount patches
#%patch570 -p1

%patch575 -p1
#%patch233 -p1
%patch576 -p1
%patch578 -p1
%patch579 -p1

# XFS patches
%patch580 -p1
#%patch581 -p1

# IRDA fixes
#%patch585 -p1
#%patch586 -p1
#%patch587 -p1
#%patch588 -p1
#%patch589 -p1
#%patch590 -p1
#%patch591 -p1

#%patch592 -p1
#%patch593 -p1
#%patch594 -p1
%patch595 -p1
#%patch596 -p1
#%patch597 -p1
#%patch598 -p1
#%patch599 -p1

%patch600 -p1
%patch601 -p1
%patch602 -p0
%patch603 -p1
%patch605 -p1
%patch606 -p1
%patch608 -p1
%patch609 -p1
%patch610 -p1
%patch611 -p1
%patch613 -p1
%patch614 -p1
%patch615 -p1
%patch616 -p1
%patch617 -p1
%patch618 -p1
%patch619 -p3
%patch624 -p1
%patch625 -p1
%patch628 -p1
%patch629 -p1
%patch630 -p1
%patch631 -p1
#%patch633 -p1
%patch635 -p1
%patch638 -p1
%patch639 -p1
%patch640 -p1
%patch641 -p1
%patch643 -p1
%patch644 -p1
%patch645 -p1
%patch646 -p1

# OV511 driver update.
install -p -m644 ov511-%ovver/ov511*.{h,c} drivers/usb
install -p -m644 ov511-%ovver/*.txt Documentation/usb

# Patch Makefile
%patch612 -p1

# Emu10k1 update.
%patch323 -p1
find emu10k1 -type f |xargs fgrep -l '<emu_wrapper.h>' |
	xargs -r perl -pi -e 's/<(emu_wrapper\.h)>/"$1"/'
find emu10k1 -type f |xargs fgrep -l 'ac97_probe_codec' |
	xargs -r perl -pi -e 's/ac97_probe_codec/ac97_probe_codec_emu/g'
find emu10k1 -type f |xargs fgrep -l 'ac97_read_proc' |
	xargs -r perl -pi -e 's/ac97_read_proc/ac97_read_proc_emu/g'
mv emu10k1/ac97_codec.c emu10k1/ac97_codec_emu.c

install -p -m644 emu10k1/*.{h,c} drivers/sound/emu10k1
install -p -m644 emu10k1/2.4/*.{h,c} drivers/sound/emu10k1

# Fix emu-midi
%patch604 -p1

# Fix emu mmap
%patch256 -p1

# Bring the Kernel Module Version Tag program
install -m644 %SOURCE13 .

# make sure the kernel has the sublevel we know it has...
perl -p -i -e "s/^SUBLEVEL.*/SUBLEVEL = %sublevel/" Makefile

# I2C patching
cd i2c-%i2cver
perl mkpatch/mkpatch.pl . ../ | patch -d ../ -p1 -E
cd ..

# fix lm_sensors patch
cd lm_sensors-%lmver
perl mkpatch/mkpatch.pl . ../ | patch -d ../ -p1 -E
cd ..

# Install ALT Linux logo
bzcat %SOURCE43 > $RPM_BUILD_DIR/linux/include/linux/linux_logo.h

# Install updated SBNI driver
#%patch614 -p1
#install -p -m644 sbni12/sbni.{h,c} drivers/net/wan
#cat sbni12/README >Documentation/networking/sbni.txt

# Install sermouse driver
patch -p1 < sermouse/sermouse.diff

# Install LIRC files
mkdir -p drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_dev/lirc_dev.{h,c} drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_gpio/lirc_gpio.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_i2c/lirc_i2c.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_serial/lirc_serial.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_sir/lirc_sir.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc.h drivers/lirc
%patch334 -p1

# Install Creative dxr3 source drivers
mkdir -p drivers/dxr3
mkdir -p Documentation/dxr3
install -p -m644 em8300-%dxr3ver/modules/*.{h,c} drivers/dxr3
install -p -m644 em8300-%dxr3ver/modules/README-* Documentation/dxr3
install -p -m644 em8300-%dxr3ver/include/linux/*.h include/linux
# Patch Makefile & Config.in
%patch620 -p1
%patch621 -p1

# Install updated QLA SCSI drivers
mkdir qla1x160
bzcat %SOURCE55 |tar x -C qla1x160
install -p -m644 qla1x160/*.{c,h} drivers/scsi
install -p -m644 qla1x160/README* drivers/scsi
# Fix timer_t bug
%patch304 -p1
# Update
%patch632 -p1
mkdir qla2x00
bzcat %SOURCE56 |tar x -C qla2x00
install -p -m644 qla2x00/*.{c,h} drivers/scsi
install -p -m644 qla2x00/README* drivers/scsi
# Patch the configs
%patch336 -p1

# Install QuickCam CVS drivers
mkdir -p drivers/usb/quickcam
install -p -m644 qce-ga/quickcam/*.{h,c} drivers/usb/quickcam
%patch475 -p1

# Install sam9407 drivers
mkdir -p drivers/sound/sam9407
install -p -m644 sam9407-%samver/kernel/*.{h,c} drivers/sound/sam9407
cat %SOURCE62 > drivers/sound/sam9407/kconfig.h
%patch634 -p1

# Install i81x framebuffer driver
install -p -m644 i810fb-final/*.{h,c} drivers/video
%patch636 -p1

# Install Siemens DVB driver

make -C DVB/driver KERNEL_LOCATION=`pwd` dvb_firm.h

install -p -m644 DVB/driver/{VES1820.c,VES1893.c,stv0299.c,tda8083.c,dvb_demodulator.h,dvb_firm.h} drivers/media/video
install -p -m644 DVB/driver/{dmxdev.c,dmxdev.h,dvb.c,dvb.h,dvb_net.c,dvb_net.h} drivers/media/video
install -p -m644 DVB/driver/{dvb_comcode.h,dvb_demux.c,dvb_demux.h,dvb_dpram4k.h} drivers/media/video
install -p -m644 DVB/driver/{dvb_types.h,dvbdev.c,dvbdev.h,dvb_filter.c,dvb_filter.h} drivers/media/video
install -p -m644 DVB/driver/{saa7146.c,saa7146_defs.h,saa7146_core.c} drivers/media/video
install -p -m644 DVB/driver/{saa7146_core.h,saa7146_v4l.c,saa7146_v4l.h} drivers/media/video
cat DVB/driver/tuner.c > drivers/media/video/tuner_dvb.c
cat DVB/driver/tuner.h > drivers/media/video/tuner_dvb.h

mkdir -p include/linux/ost
install -p -m644 DVB/ost/include/ost/*.h include/linux/ost
%patch637 -p1

# Install updated radeon framebuffer driver
install -p -m644 radeonfb-0.1.0-ve.1/*.{h,c} drivers/video

# Install updated iSCSI driver
%patch200 -p1
# Update config
%patch633 -p1

# RSBAC patches
%patch700 -p1
%if %rsbacbugfixver
%patch701 -p1
%endif
%patch702 -p1
%patch703 -p1
%patch704 -p1
#%patch706 -p1
#%patch707 -p1
#%patch708 -p1

%patch800 -p1
%patch801 -p1

# get rid of unwanted files
find . -name '*~' -o -name '*.orig'|xargs rm -f

###
### build
###

# ldv: This package requires some magic
%buildmulti
# We won't debug kernel, do we?
%remove_optflags %optflags_debug

# fakeroot go home!
unset LD_PRELOAD ||:

# k6 cannot be SMP.
%ifarch k6
%define BUILD_SMP 0
%define BUILD_SECURE_SMP 0
%define BUILD_RSBAC_SMP 0
%endif

# adjust BUILD_CUSTOM_*
%if !%BUILD_CUSTOM
%define BUILD_CUSTOM_PCMCIA 0
%define BUILD_CUSTOM_ALSA 0
%endif

# define kernel arch.
%ifarch %ix86
%define karch i386
%else
%ifarch sparc64
%define karch %_target_cpu
%else
%define karch %_arch
%endif
%endif

Suffix=
What=

# Optimization for athlon avaiable only in gcc 2.96
%ifarch athlon
%define USE_GCC_COMPAT 0
%endif

%if %USE_GCC_COMPAT
if [ -e /usr/bin/kgcc ]; then
	KGCC_PARAM="CC=/usr/bin/kgcc"
else
	KGCC_PARAM="CC=/usr/bin/gcc"
fi
%else
	KGCC_PARAM="CC=/usr/bin/gcc"
%endif

MakeVars()
{
	# Is this a special kernel we want to build?
	if [ -n "$1" ] ; then
		Suffix="-$1"
		What="$1 kernel"
	else
		Suffix=
		What="NORMAL kernel"
	fi
}

BuildKernel() {
	echo "Building config for the $What"

	Config=%_target_cpu$Suffix
	KernelVer=%KVERREL$Suffix

	cp -p $RPM_SOURCE_DIR/kernel-%kversion-$Config.config arch/%karch/defconfig
	rm -f .config
	# make sure SUBLEVEL and EXTRAVERSION say what we want them to say
	perl -pi -e "s/^SUBLEVEL.*/SUBLEVEL = %sublevel/; s/^EXTRAVERSION.*/EXTRAVERSION = -%release$Suffix/" Makefile
	make mrproper
	make oldconfig

	cmp -s .config $RPM_SOURCE_DIR/kernel-%kversion-$Config.config || \
		cp -vf .config $RPM_SOURCE_DIR/kernel-%kversion-$Config.config

	echo "Building dependencies for the $What"

	make $KGCC_PARAM dep
	make include/linux/version.h

	echo "Building the $What"

	%make_build $KGCC_PARAM bzImage

	if grep -q '^CONFIG_MODULES=y' .config; then
		echo "Building modules for the $What"
		%make_build $KGCC_PARAM modules
		find include/linux/modules -size 0 |while read file; do
			echo >"$file"
		done
	fi

	mkdir -p $RPM_BUILD_ROOT/boot
	install -p -m644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
	install -p -m644 arch/%karch/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer

	if grep -q '^CONFIG_MODULES=y' .config; then
		make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
	fi
	cc -o rhkmvtag rhkmvtag.c init/version.o
	./rhkmvtag >$RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag ||:
	rm -f rhkmvtag
	rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
}

BuildDRM() {
	echo "Building DRM for the $What"
	if grep -q '^CONFIG_DRM=y' .config; then
	pushd drm-%drmver
	    make -f Makefile.linux clean
	    DRM_MODULES=""
	    if grep -q '^CONFIG_DRM_TDFX=m' ../.config; then
		DRM_MODULES="tdfx.o"
	    fi
	    if grep -q '^CONFIG_DRM_GAMMA=m' ../.config; then
		DRM_MODULES="$DRM_MODULES gamma.o"
	    fi
	    if grep -q '^CONFIG_DRM_R128=m' ../.config; then
		DRM_MODULES="$DRM_MODULES r128.o"
	    fi
	    if grep -q '^CONFIG_DRM_RADEON=m' ../.config; then
		DRM_MODULES="$DRM_MODULES radeon.o"
	    fi
	    if grep -q '^CONFIG_DRM_I810=m' ../.config; then
		DRM_MODULES="$DRM_MODULES i810.o"
	    fi
	    if grep -q '^CONFIG_DRM_MGA=m' ../.config; then
		DRM_MODULES="$DRM_MODULES mga.o"
	    fi
	    %if %BUILD_DRM_SIS
		DRM_MODULES="$DRM_MODULES sis.o"
		SIS=1
	    %else
		SIS=
	    %endif
	    %make_build $KGCC_PARAM CFLAGS="-I../include $OPT_FLAGS" TREE=.. SIS=$SIS -f Makefile.linux $DRM_MODULES

	    install -p -m644 $DRM_MODULES $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/kernel/drivers/char/drm
	popd
	else
	    echo "Building DRM for the $What disabled in config"
	fi
}

BuildDXR2() {
	echo "Building DXR2 for the $What"
	pushd dxr2
	    make clean
	    %make_build DIRS='$(MODS)' $KGCC_PARAM CFLAGS="-DMODULE -D__KERNEL__=1 -I../sysinclude -D_LOOSE_KERNEL_NAMES -DMAKING_MODULES=1 -DMODVERSIONS -I../../include -include ../../include/linux/modversions.h $OPT_FLAGS \$(SMP)"
	    mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/kernel/drivers/media/dxr2
	    install -p -m644 anp82/anp82.o bt865/bt865.o pcm1723/pcm1723.o \
		tc6807af/tc6807af.o vxp524/vxp524.o zivaDS/zivaDS.o dxr2/dxr2.o \
		$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/kernel/drivers/media/dxr2
	popd
}

BuildPCMCIA() {
	echo "Building PCMCIA for the $What"

	pushd pcmcia
		make clean DIRS='$(KDIRS)'
		export FORCED_CONF_SRC=2
		./Configure -n --kernel=$RPM_BUILD_DIR/linux \
			--target=$RPM_BUILD_ROOT \
			--moddir=/lib/modules/%KVERREL$Suffix \
			--srctree \
			--notrust \
			--cardbus \
			--nopnp \
			--sysv --srctree --rcdir=%_sysconfdir/rc.d
		%make_build DIRS='$(KDIRS)' $KGCC_PARAM \
			CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes" all
		mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/pcmcia
		%make_install install DIRS='$(KDIRS)' PREFIX=$RPM_BUILD_ROOT
		rm -rf $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/net
		mkdir -p $RPM_BUILD_ROOT%_usrsrc/linux/pcmcia-cs-%pcmciaver/include/pcmcia
		sed -e "s|$RPM_BUILD_DIR/linux|%_usrsrc/linux|;s|$RPM_BUILD_ROOT||;" \
			<include/pcmcia/config.h \
			>$RPM_BUILD_ROOT%_usrsrc/linux/pcmcia-cs-%pcmciaver/include/pcmcia/config.h
	popd
}

BuildAlsa() {
	echo "Building ALSA for the $What"

	pushd alsa
		perl -pi -e 's/^COPTS=.*/COPTS=/' Makefile.conf.in
		perl -pi -e 's/^c_opts=.*/c_opts=/' Makefile.conf.in
		export $KGCC_PARAM
		[ -e Makefile.conf ] && make mrproper

		CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -DLINUX" ./configure \
			--with-kernel=$RPM_BUILD_DIR/linux \
			--with-processor=%_target_cpu --with-smp=auto \
			--with-isapnp --with-sequencer=yes --with-oss=yes \
			--with-moddir=$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		make COPTS="\$(c_opts) $RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes -DLINUX" all

		mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		install -p -m644 modules/*.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		unset CC
	popd
}

BuildHackAlsa() {
	echo "Building HACK_ALSA for the $What"

	pushd alsa-driver-%hackalsaver
		perl -pi -e 's/^COPTS=.*/COPTS=/' Makefile.conf.in
		perl -pi -e 's/^c_opts=.*/c_opts=/' Makefile.conf.in
		export $KGCC_PARAM
		[ -e Makefile.conf ] && make mrproper

		CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -DLINUX" ./configure \
			--with-kernel=$RPM_BUILD_DIR/linux \
			--with-processor=%_target_cpu --with-smp=auto \
			--with-isapnp --with-sequencer=yes --with-oss=yes \
			--with-moddir=$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		make COPTS="\$(c_opts) $RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes -DLINUX" all

		mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/hackalsa
		install -p -m644 modules/*.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/hackalsa
		unset CC
	popd
}

SaveHeaders() {
	echo "Saving headers for the $What"
	mkdir -p $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix
	install -p -m644 include/linux/autoconf.h \
		$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/autoconf.h
	install -p -m644 include/linux/version.h \
		$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/version.h
	if [ -e include/linux/modversions.h ]; then
		sed -e "s,linux/modules/,%_libdir/kernel/%KVERREL$Suffix/modules/,g" <include/linux/modversions.h \
			>$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/modversions.h
	fi
	cp -a include/linux/modules $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/modules
	pushd $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix
		/usr/bin/h2ph -d . *.h
	popd
}

StripModules() {
	echo "Striping modules for the $What"
	%strip_relocatable -g $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix
}

BuildSecureSMP () {
	MakeVars smp-secure
%if %BUILD_SECURE_SMP
	BuildKernel
%if %BUILD_DRM
	BuildDRM
%endif
	BuildDXR2
	BuildPCMCIA
	BuildAlsa
%if %BUILD_HACK_ALSA
	BuildHackAlsa
%endif
	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildSecureUP () {
	MakeVars up-secure
%if %BUILD_SECURE_UP
	BuildKernel
%if %BUILD_DRM
	BuildDRM
%endif
	BuildDXR2
	BuildPCMCIA
	BuildAlsa
%if %BUILD_HACK_ALSA
	BuildHackAlsa
%endif
	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildRsbacSMP () {
	MakeVars smp-rsbac
%if %BUILD_RSBAC_SMP
	BuildKernel
%if %BUILD_DRM
	BuildDRM
%endif
	BuildDXR2
	BuildPCMCIA
	BuildAlsa
%if %BUILD_HACK_ALSA
	BuildHackAlsa
%endif
	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildRsbacUP () {
	MakeVars up-rsbac
%if %BUILD_RSBAC_UP
	BuildKernel
%if %BUILD_DRM
	BuildDRM
%endif
	BuildDXR2
	BuildPCMCIA
	BuildAlsa
%if %BUILD_HACK_ALSA
	BuildHackAlsa
%endif
	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildSMP () {
	MakeVars smp
%if %BUILD_SMP
	BuildKernel
%if %BUILD_DRM
	BuildDRM
%endif
	BuildDXR2
	BuildPCMCIA
	BuildAlsa
%if %BUILD_HACK_ALSA
	BuildHackAlsa
%endif
	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildUp () {
	MakeVars up
%if %BUILD_UP
	BuildKernel
%if %BUILD_DRM
	BuildDRM
%endif
	BuildDXR2
	BuildPCMCIA
	BuildAlsa
%if %BUILD_HACK_ALSA
	BuildHackAlsa
%endif
	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildBoot () {
	MakeVars boot
%if %BUILD_BOOT
	BuildKernel
	BuildPCMCIA

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildCUSTOM () {
	MakeVars %CUSTOM
%if %BUILD_CUSTOM
	BuildKernel
%if %BUILD_CUSTOM_DRM
	BuildDRM
%endif
%if %BUILD_CUSTOM_DXR2
	BuildDXR2
%endif
%if %BUILD_CUSTOM_PCMCIA
	BuildPCMCIA
%endif
%if %BUILD_CUSTOM_ALSA
	BuildAlsa
%if %BUILD_HACK_ALSA
	BuildHackAlsa
%endif
%endif
	StripModules
	SaveHeaders
%else
	echo "Building custom $What disabled"
%endif
}

###
# DO it...
###

mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL
ln -snf kernel/linux-%KVERREL $RPM_BUILD_ROOT%_usrsrc/linux

# Patch CFLAGS in Makefile
OPT_FLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes -fno-strict-aliasing"
perl -pi -e "s/^HOSTCFLAGS.*/HOSTCFLAGS = $OPT_FLAGS/" Makefile
perl -pi -e "s/^CFLAGS_KERNEL.*/CFLAGS_KERNEL := $OPT_FLAGS/" Makefile
perl -pi -e 's/^CFLAGS :=.*/CFLAGS :=/' Makefile
perl -pi -e 's/-fomit-frame-pointer -fno-strict-aliasing -fno-common//g' Makefile
perl -pi -e 's|^(include arch/\$\(ARCH\)/Makefile)$|$1\nCFLAGS := \$(CPPFLAGS)|' Makefile
perl -pi -e 's|^(MODFLAGS \+= -DMODVERSIONS -include \$\(HPATH\)/linux/modversions.h).*|$1 \$(CFLAGS_KERNEL)|' Makefile

BuildCUSTOM
BuildBoot
BuildSecureSMP
BuildSecureUP
BuildRsbacSMP
BuildRsbacUP
BuildSMP
BuildUp

###
### install
###
%install
echo "Building all the rest"

# Install config files.
mkdir -p configs
install -p -m644 $RPM_SOURCE_DIR/kernel-%kversion-*.config configs

# Install more driver documentation
for f in `find drivers -type f -name README.\*`; do
	install -p -m644 -D "$f" "Documentation/$f"
done

# Install -ac ch-log
bzcat %SOURCE44 >Documentation/kernel.notes

# Install Alsa documentation.
mkdir -p Documentation/sound/alsa
for f in COPYING INSTALL FAQ README doc/SOUNDCARDS WARNING; do
    install -p -m644 "alsa-driver-%alsaver/$f" Documentation/sound/alsa
done

# Install Alsa headers.
mkdir -p $RPM_BUILD_ROOT%_usrsrc/linux/include/linux
for f in asound.h asoundid.h asequencer.h ainstr_simple.h ainstr_gf1.h ainstr_iw.h; do
	install -p -m644 "alsa-driver-%alsaver/include/$f" \
		$RPM_BUILD_ROOT%_usrsrc/linux/include/linux
done

%if %BUILD_HACK_ALSA
# Install Alsa documentation.
mkdir -p Documentation/sound/hackalsa
for f in COPYING INSTALL FAQ README doc/SOUNDCARDS WARNING; do
    install -p -m644 "alsa-driver-%hackalsaver/$f" Documentation/sound/hackalsa
done

# Install HackAlsa headers.
mkdir -p $RPM_BUILD_ROOT%_includedir/sound
cp -f alsa-driver-%hackalsaver/include/*.h \
		$RPM_BUILD_ROOT%_includedir/sound
%endif

# Install Emu10k1 documentation
mkdir -p Documentation/sound/emu10k1
install -p -m644 emu10k1/docs/* Documentation/sound/emu10k1

# /Includes links.
mkdir -p $RPM_BUILD_ROOT%_includedir
ln -snf ../src/linux/include/linux $RPM_BUILD_ROOT%_includedir/linux

# Copy all sources.
tar cf - . |tar xf - -C $RPM_BUILD_ROOT%_usrsrc/linux
install -p -m644 %SOURCE20 $RPM_BUILD_ROOT%_usrsrc/linux/Documentation

# Come from initscripts.
ln -snf /sbin/installkernel $RPM_BUILD_ROOT%_usrsrc/linux/arch/%karch/boot/install.sh

ln -snf ../src/linux/include/asm $RPM_BUILD_ROOT%_includedir/asm

# Make sure EXTRAVERSION says what we want it to say (in sources).
perl -pi -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%release/" $RPM_BUILD_ROOT%_usrsrc/linux/Makefile

# Use the standard i586 config in source.
install -p -m644 %SOURCE20 $RPM_BUILD_ROOT%_usrsrc/linux/.config
install -p -m644 %SOURCE20 $RPM_BUILD_ROOT%_usrsrc/linux/arch/%karch/defconfig

mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/drivers

# Clean up the destination.
make clean -C $RPM_BUILD_ROOT%_usrsrc/linux/pcmcia DIRS='$(KDIRS)'

make mrproper -C $RPM_BUILD_ROOT%_usrsrc/linux/alsa-driver-%alsaver ||:

[ -d $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/alsa-driver-%alsaver ] ||
	mv $RPM_BUILD_ROOT%_usrsrc/linux/alsa-driver-%alsaver \
		$RPM_BUILD_ROOT%_usrsrc/kernel/drivers

%if BUILD_HACK_ALSA
[ -d $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/hackalsa-driver-%hackalsaver ] ||
	mv $RPM_BUILD_ROOT%_usrsrc/linux/alsa-driver-%hackalsaver \
		$RPM_BUILD_ROOT%_usrsrc/kernel/drivers
%endif

make -C $RPM_BUILD_ROOT%_usrsrc/linux/drm -f Makefile.linux clean

make -C $RPM_BUILD_ROOT%_usrsrc/linux/dxr2 clean
mv -f $RPM_BUILD_ROOT%_usrsrc/linux/dxr2/makefile_old $RPM_BUILD_ROOT%_usrsrc/linux/dxr2/makefile

%if BUILD_DRM
[ -d $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/drm-%drmver ] ||
	mv $RPM_BUILD_ROOT%_usrsrc/linux/drm-%drmver \
		$RPM_BUILD_ROOT%_usrsrc/kernel/drivers
%endif

[ -d $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/dxr2 ] ||
	mv $RPM_BUILD_ROOT%_usrsrc/linux/dxr2 \
		$RPM_BUILD_ROOT%_usrsrc/kernel/drivers

make mrproper -C $RPM_BUILD_ROOT%_usrsrc/linux
make oldconfig -C $RPM_BUILD_ROOT%_usrsrc/linux
make symlinks -C $RPM_BUILD_ROOT%_usrsrc/linux
make include/linux/version.h -C $RPM_BUILD_ROOT%_usrsrc/linux

# We don't ship dependencies.
find $RPM_BUILD_ROOT%_usrsrc/linux/ -name '.*depend' |xargs -r rm -f

rm -rf $RPM_BUILD_ROOT%_usrsrc/linux/include/linux/modules/*

# Universal headers.
for n in autoconf modversions version; do
	echo "#include </var/run/kernel/$n.h>" >"$RPM_BUILD_ROOT%_usrsrc/linux/include/linux/$n.h"
	chmod 644 "$RPM_BUILD_ROOT%_usrsrc/linux/include/linux/$n.h"
done

# Header subpackage.
mkdir -p $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
cp -a $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL/include/{asm,asm-%karch,asm-generic,linux,net,scsi,video,pcmcia,rsbac} \
    $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
%ifarch alpha sparc sparc64
cp -a $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL/include/math-emu $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
%endif

# Install menu and icon.
#mkdir -p $RPM_BUILD_ROOT{%_sbindir,%_mandir/man8}
install -p -m644 -D %SOURCE41 $RPM_BUILD_ROOT%_miconsdir/%name.xpm
install -p -m644 -D %SOURCE42 $RPM_BUILD_ROOT%_menudir/%name-source

FindKM()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi

	F="km$Suffix.files"

	:>"$F"

	KernelVer=%KVERREL$Suffix

	echo "/boot/vmlinuz-$KernelVer" >>"$F"
	echo "/boot/System.map-$KernelVer" >>"$F"
	echo "%_libdir/kernel/$KernelVer" >>"$F"

	echo "%%dir /lib/modules/$KernelVer" >>"$F"

	find $RPM_BUILD_ROOT/lib/modules/$KernelVer -mindepth 1 -maxdepth 1 \! -type l |
		sed -e "s|$RPM_BUILD_ROOT||g" |
		fgrep -v /lib/modules/$KernelVer/modules. |
		fgrep -v /alsa |
		fgrep -v /hackalsa >>"$F"

        echo "%%config(noreplace) /lib/modules/$KernelVer/modules.*" >>"$F"
}

FindAlsa()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="alsa$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/alsa" >>"$F"
	echo "%%doc Documentation/sound/alsa/*" >>"$F"
}

FindHackAlsa()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="hackalsa$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/hackalsa" >>"$F"
	echo "%%doc Documentation/sound/hackalsa/*" >>"$F"
}

%if %BUILD_CUSTOM
FindKM %CUSTOM
%endif

%if %BUILD_BOOT
FindKM boot
%endif

%if %BUILD_SECURE_SMP
FindKM smp-secure
%endif

%if %BUILD_SECURE_UP
FindKM up-secure
%endif

%if %BUILD_RSBAC_SMP
FindKM smp-rsbac
%endif

%if %BUILD_RSBAC_UP
FindKM up-rsbac
%endif

%if %BUILD_SMP
FindKM smp
%endif

%if %BUILD_UP
FindKM up
%endif

%ifarch %ix86

%if %BUILD_CUSTOM_ALSA
FindAlsa %CUSTOM
%if %BUILD_HACK_ALSA
FindHackAlsa %CUSTOM
%endif
%endif

%if %BUILD_SECURE_SMP
FindAlsa smp-secure
%if %BUILD_HACK_ALSA
FindHackAlsa smp-secure
%endif
%endif

%if %BUILD_SECURE_UP
FindAlsa up-secure
%if %BUILD_HACK_ALSA
FindHackAlsa up-secure
%endif
%endif

%if %BUILD_RSBAC_SMP
FindAlsa smp-rsbac
%if %BUILD_HACK_ALSA
FindHackAlsa smp-rsbac
%endif
%endif

%if %BUILD_RSBAC_UP
FindAlsa up-rsbac
%if %BUILD_HACK_ALSA
FindHackAlsa up-rsbac
%endif
%endif

%if %BUILD_SMP
FindAlsa smp
%if %BUILD_HACK_ALSA
FindHackAlsa smp
%endif
%endif

%if %BUILD_UP
FindAlsa up
%if %BUILD_HACK_ALSA
FindHackAlsa up
%endif
%endif

%endif

###
### scripts
###

# Do this for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.

%if %BUILD_SECURE_SMP
%pre smp-secure
/sbin/modprobe loop &>/dev/null ||:
%preun smp-secure
/sbin/modprobe loop &>/dev/null ||:
%post smp-secure
ln -snf vmlinuz-%KVERREL-smp-secure /boot/vmlinuz-smp-secure
ln -snf initrd-%KVERREL-smp-secure.img /boot/initrd-smp-secure.img
/sbin/installkernel -a -c %KVERREL-smp-secure ||:
[ -f /boot/initrd-smp-secure.img ] || rm -f /boot/initrd-smp-secure.img
%endif

%if %BUILD_SECURE_UP
%pre up-secure
/sbin/modprobe loop &>/dev/null ||:
%preun up-secure
/sbin/modprobe loop &>/dev/null ||:
%post up-secure
ln -snf vmlinuz-%KVERREL-up-secure /boot/vmlinuz-up-secure
ln -snf initrd-%KVERREL-up-secure.img /boot/initrd-up-secure.img
/sbin/installkernel -a -c %KVERREL-up-secure ||:
[ -f /boot/initrd-up-secure.img ] || rm -f /boot/initrd-up-secure.img
%endif

%if %BUILD_RSBAC_SMP
%pre smp-rsbac
/sbin/modprobe loop &>/dev/null ||:
%preun smp-rsbac
/sbin/modprobe loop &>/dev/null ||:
%post smp-rsbac
ln -snf vmlinuz-%KVERREL-smp-rsbac /boot/vmlinuz-smp-rsbac
ln -snf initrd-%KVERREL-smp-rsbac.img /boot/initrd-smp-rsbac.img
/sbin/installkernel -a -c %KVERREL-smp-rsbac ||:
[ -f /boot/initrd-smp-rsbac.img ] || rm -f /boot/initrd-smp-rsbac.img
%endif

%if %BUILD_RSBAC_UP
%pre up-rsbac
/sbin/modprobe loop &>/dev/null ||:
%preun up-rsbac
/sbin/modprobe loop &>/dev/null ||:
%post up-rsbac
ln -snf vmlinuz-%KVERREL-up-rsbac /boot/vmlinuz-up-rsbac
ln -snf initrd-%KVERREL-up-rsbac.img /boot/initrd-up-rsbac.img
/sbin/installkernel -a -c %KVERREL-up-rsbac ||:
[ -f /boot/initrd-up-rsbac.img ] || rm -f /boot/initrd-up-rsbac.img
%endif

%if %BUILD_SMP
%pre smp
/sbin/modprobe loop &>/dev/null ||:
%preun smp
/sbin/modprobe loop &>/dev/null ||:
%post smp
ln -snf vmlinuz-%KVERREL-smp /boot/vmlinuz-smp
ln -snf initrd-%KVERREL-smp.img /boot/initrd-smp.img
/sbin/installkernel -a -c %KVERREL-smp ||:
[ -f /boot/initrd-smp.img ] || rm -f /boot/initrd-smp.img
%endif

%if %BUILD_UP
%pre up
/sbin/modprobe loop &>/dev/null ||:
%preun up
/sbin/modprobe loop &>/dev/null ||:
%post up
ln -snf vmlinuz-%KVERREL-up /boot/vmlinuz-up
ln -snf initrd-%KVERREL-up.img /boot/initrd-up.img
/sbin/installkernel -a -c %KVERREL-up ||:
[ -f /boot/initrd-up.img ] || rm -f /boot/initrd-up.img
%endif

%if %BUILD_BOOT
%pre boot
/sbin/modprobe loop &>/dev/null ||:
%preun boot
/sbin/modprobe loop &>/dev/null ||:
%endif

%if %BUILD_CUSTOM
%pre %CUSTOM
/sbin/modprobe loop &>/dev/null ||:
%preun %CUSTOM
/sbin/modprobe loop &>/dev/null ||:
%post %CUSTOM
/sbin/installkernel -a -c %KVERREL-%CUSTOM ||:
%endif

%if %BUILD_HEADERS
%post headers
/usr/sbin/update-alternatives --install %_libdir/kernel/include kernel_include %_libdir/kernel/%KVERREL/include 24

%preun headers
/usr/sbin/update-alternatives --remove kernel_include %_libdir/kernel/%KVERREL/include

%triggerpostun headers -- kernel24-headers < 2.4.9-alt5
/usr/sbin/update-alternatives --auto kernel_include

%triggerpostun headers -- kernel22-headers < 2.2.19-alt7
/usr/sbin/update-alternatives --auto kernel_include
%endif

%if %BUILD_SOURCE
%post source
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24
%update_menus

%preun source
/usr/sbin/update-alternatives --remove usr_src_linux /usr/src/kernel/linux-%KVERREL

%postun source
%clean_menus

%triggerpostun source -- kernel-headers
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel24-headers < 2.4.8
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel-source
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel24-source < 2.4.8
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel24-source < 2.4.9-alt5
/usr/sbin/update-alternatives --auto usr_src_linux

%triggerpostun source -- kernel22-source < 2.2.19-alt7
/usr/sbin/update-alternatives --auto usr_src_linux
%endif
	

###
### file lists
###

### KERNELS AND MODULES ###

### NORMAL KERNEL
%if %BUILD_UP
%files up -f km-up.files
%endif

### SMP KERNEL
%if %BUILD_SMP
%files smp -f km-smp.files
%endif

### SECURE_SMP KERNEL
%if %BUILD_SECURE_SMP
%files smp-secure -f km-smp-secure.files
%endif

### SECURE_UP KERNEL
%if %BUILD_SECURE_UP
%files up-secure -f km-up-secure.files
%endif

### RSBAC_SMP KERNEL
%if %BUILD_RSBAC_SMP
%files smp-rsbac -f km-smp-rsbac.files
%endif

### RSBAC_UP KERNEL
%if %BUILD_RSBAC_UP
%files up-rsbac -f km-up-rsbac.files
%endif

### %CUSTOM KERNEL
%if %BUILD_CUSTOM
%files %CUSTOM -f km-%CUSTOM.files
%endif

### BOOT KERNEL
%if %BUILD_BOOT
%files boot -f km-boot.files
%endif

### ALSA MODULES for kernels
%ifarch %ix86

%if %BUILD_UP
%files -n alsa24-up -f alsa-up.files
%if %BUILD_HACK_ALSA
%files -n hackalsa24-up -f hackalsa-up.files
%endif
%endif

%if %BUILD_SMP
%files -n alsa24-smp -f alsa-smp.files
%if %BUILD_HACK_ALSA
%files -n hackalsa24-smp -f hackalsa-smp.files
%endif
%endif

%if %BUILD_SECURE_SMP
%files -n alsa24-smp-secure -f alsa-smp-secure.files
%if %BUILD_HACK_ALSA
%files -n hackalsa24-smp-secure -f hackalsa-smp-secure.files
%endif
%endif

%if %BUILD_SECURE_UP
%files -n alsa24-up-secure -f alsa-up-secure.files
%if %BUILD_HACK_ALSA
%files -n hackalsa24-up-secure -f hackalsa-up-secure.files
%endif
%endif

%if %BUILD_RSBAC_SMP
%files -n alsa24-smp-rsbac -f alsa-smp-rsbac.files
%if %BUILD_HACK_ALSA
%files -n hackalsa24-smp-rsbac -f hackalsa-smp-rsbac.files
%endif
%endif

%if %BUILD_RSBAC_UP
%files -n alsa24-up-rsbac -f alsa-up-rsbac.files
%if %BUILD_HACK_ALSA
%files -n hackalsa24-up-rsbac -f hackalsa-up-rsbac.files
%endif
%endif

%if %BUILD_CUSTOM_ALSA
%files -n alsa24-%CUSTOM -f alsa-%CUSTOM.files
%if %BUILD_HACK_ALSA
%files -n hackalsa24-%CUSTOM -f hackalsa-%CUSTOM.files
%endif
%endif

%endif

### SOURCE, HEADERS AND DOCS ###

### KERNEL HEADERS
%if %BUILD_HEADERS
%files headers
%_libdir/kernel/%KVERREL
%endif

### KERNEL SOURCE
%if %BUILD_SOURCE
%files source
%_menudir/*
%_miconsdir/*.xpm
%_usrsrc/kernel/linux-%KVERREL/COPYING
%_usrsrc/kernel/linux-%KVERREL/CREDITS
%_usrsrc/kernel/linux-%KVERREL/Documentation
%_usrsrc/kernel/linux-%KVERREL/MAINTAINERS
%_usrsrc/kernel/linux-%KVERREL/Makefile
%_usrsrc/kernel/linux-%KVERREL/README
%_usrsrc/kernel/linux-%KVERREL/REPORTING-BUGS
%_usrsrc/kernel/linux-%KVERREL/Rules.make
%_usrsrc/kernel/linux-%KVERREL/rhkmvtag.c
%_usrsrc/kernel/linux-%KVERREL/configs
%_usrsrc/kernel/linux-%KVERREL/crypto
%_usrsrc/kernel/linux-%KVERREL/drivers
%_usrsrc/kernel/linux-%KVERREL/fs
%_usrsrc/kernel/linux-%KVERREL/init
%_usrsrc/kernel/linux-%KVERREL/ipc
%_usrsrc/kernel/linux-%KVERREL/kernel
%_usrsrc/kernel/linux-%KVERREL/lib
%_usrsrc/kernel/linux-%KVERREL/mm
#%_usrsrc/kernel/linux-%KVERREL/modules
%_usrsrc/kernel/linux-%KVERREL/net
%_usrsrc/kernel/linux-%KVERREL/rsbac
%_usrsrc/kernel/linux-%KVERREL/scripts
#%_usrsrc/kernel/linux-%KVERREL/security
%_usrsrc/kernel/linux-%KVERREL/sermouse
%dir %_usrsrc/kernel/linux-%KVERREL/arch
%_usrsrc/kernel/linux-%KVERREL/arch/%karch
%_usrsrc/kernel/linux-%KVERREL/pcmcia*
%_usrsrc/kernel/linux-%KVERREL/freeswan*
%_usrsrc/kernel/linux-%KVERREL/include

### ALSA DRIVER SOURCE
%files -n alsa24-source
%_usrsrc/kernel/drivers/alsa-driver-%alsaver
%if %BUILD_HACK_ALSA
%files -n hackalsa24-source
%_usrsrc/kernel/drivers/alsa-driver-%hackalsaver

%files -n alsa-driver-headers
%_includedir/sound
%endif
%endif

### DRM DRIVER SOURCE
%if %BUILD_DRM
%files -n drm-source
%_usrsrc/kernel/drivers/drm-%drmver
%endif

### DXR2 DRIVER SOURCE
%files -n dxr2-source
%_usrsrc/kernel/drivers/dxr2

### KERNEL DOCS
%if %BUILD_DOCS
%files doc
#%ifarch %ix86
#%_mandir/man9/*
#%endif
%doc Documentation/*
%endif

%changelog
* Fri Oct 19 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.12-alt1
- Added
  + ISCSI driver
- Fixed
  + Here, in this kernel some security-related bugs (Symlink & Ptrace)
    are fixed
  + IPseC bug by CONFIG_IPSEC_DEBUG=y
- Updated
  + ac-patch to -ac3
  + Kernel version to 2.4.12
  + ov511 driver to 1.43
  + Bttv to 0.7.83 version
  + EMU10K1 driver to 20011019
  + Updated XFS & JFS filesystems

* Mon Oct 08 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.10-alt1
- Added
  + Support for i860 in agpgart
- Updated
  + ac-patch to -ac7
  + Kernel version to 2.4.10
  + Andrea patches
  + drx3 driver to 0.8.2
  + Creative EMU10K1 drivers
  + HackALSA drivers to 0.9.0beta8a
- Fixed
  + Fixed -athlon configs - now it contains only athlon avaiables
    ide drivers
  + Siemens DVB compiling in path other than /usr/src/RPM
  + Config many serial ports patch - make xconfig now possible

* Wed Sep 19 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.9-alt5
- Features
  + Now we build with kernel24 all avaiable journal filesystems
  + emu10k1-tools package now build in another spec
- Added
  + alsa-driver-headers package which contains headers for hackalsa
  + Support xfs filesystem
  + Some irda fixes
  + I81x framebuffer driver
  + Some mandrake patches
  + SAM9407 sound card driver
  + Siemens DVB driver 0.9.3
- Fixed
  + Default codepage in configs
- Updated
  + Pcmcia-cs to 3.1.29
  + Emu10k1 drivers to 20010917
  + BTTV driver to 0.7.79
  + btaudio driver
  + QuickCam driver from latest CVS
  + Radeon framebuffer driver

* Tue Sep 11 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.9-alt4
- Added
  + Support USB GeneSys network links
  + Support for LINE1 input for SB16 Vibra cards with sf16-fmd2 radio chip
  + Support for zisofs
- Updated
  + ac-patch to -ac10
  + lm_sensors & i2c to 2.6.1
  + BTTV driver to 0.7.78
  + ov511 driver to 1.42
- Fixed
  + post install for kernel-headers & kernel-source
  + Now we don't null modules.* files

* Tue Sep 04 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.9-alt3
- Features
  + This kernel seems to be stable :-)
- Updated
  + ac-patch to -ac7
  + devfs
  + Andrea patches
- Fixed
  + msync bug
  + BuildRequires & Requires for kernel24-source package

* Mon Sep 03 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.9-alt2
- Features
  + This kernel is possibly unstable so use it with care
- Updated
  + ac-patch to -ac5
  + JFS filesystem to 1.0.3
  + QLogic SCSI drivers update
  + Applied some Mandrake patches

* Thu Aug 30 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.9-alt1
- Features
  + This kernel is possibly unstable so use it with care
- Fixed
  + AGP pci_ids to support new chipsets
  + USB Storage ISD200 support
  + IXJ Telephony driver fix
- Updated
  + Kernel to 2.4.9
  + ac-patch to -ac3
  + Emu10k1 drivers to 20010829
  + DRX3 drivers to 0.8.1
  + Hackalsa to 0.9.6beta7
  + Emu-tools package
  + LIRC to 0.6.4

* Wed Aug 22 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.8-alt2
- Fixed
  + Generating *.ph files
- Updated
  + ac-patch to -ac8

* Tue Aug 14 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.8-alt1
- Features
  + Now we build all kernels gcc 2.96 by default
  + Now kernel 2.4.8 contains both drm drivers for XFree86 4.0 & 4.1 and
    you may define them from kernel config. BUILD_DRM option temporary
    disabled. May be i'll use it for build kernel modules for XFree86
    DRM snapshots.
  + New emu10k1 drivers contains sequencer support code. It's greate, but
    may be unstable, so you may disable this feature in config. (My SbLive
    works fine with this feature.)
- Changed:
  + kernel24-headers subpackage now lives in %_libdir/kernel/%KVERREL directory;
  + Common part of kernel-headers from various kernel versions now in
    kernel-headers-common package;
  + kernel24-source package now contains include subtree in itself.
- Added
  + Hisax patch
  + cpus_allowed patch
  + Tux patches from Andrea
- Fixed
  + Andrea Arcanelli bug
  + Some patches
  + Now we create {version,autoconf,modversions}.ph in
    /usr/lib/kernel/`uname -r`
  + kernel24-headers & kernel24-source %post's scripts
  + Provides of kernel packages to compatible with new kernel22 packages
- Updated
  + ac-patch to -ac3
  + Kernel to 2.4.8
  + Emu10k1 drivers to 20010814
  + DRX3 drivers to 0.8.0
  + Pcmcia-cs to 3.1.28
  + Emu-tools package

* Wed Aug 08 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.7-alt3
- Added
  + ext3 filesystem (in .ac patch)
  + JFS filesystem
  + VLAN support
  + BCM5820 Hardware crypto support
  + Some Mandrake patches
- Fixed
  + Some RSBAC patches
- Updated
  + ac-patch to -ac9
  + Int. crypto patch

* Thu Aug 02 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.7-alt2
- Added
  + Creative DXR3 drivers
- Updated
  + ac-patch to -ac3
  + emu10k1 to 20010801
  + Ov511 driver to 1.41
- Fixed
  + Some RSBAC patches
  + Some spec cleanup
  + Custom build additional packages

* Sun Jul 29 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.7-alt1
- Added
  + Removed psaux_waiting patch
  + Removed bttv patch as it's 0.7.72 already in ac-thread
- Fixed
  + BuildReq if BUILD_EMUTOOLS
  + APM realmode_poweroff symbol
  + Some other small fixes
  + ISO9660 options parsing
- Updated
  + Kernel to 2.4.7
  + ac-patch to -ac2
  + Hackalsa to 0.9.6beta6
  + RSBAC to 1.1.2-pre9

* Wed Jul 11 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.6-alt2
- Added
  + byacc to BuildReq
- Updated
  + RSBAC to 1.1.2-pre7
  + Freeswan to 1.91

* Tue Jul 10 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.6-alt1
- Added
  + Install external DRM modules only if they're included in .config
  + Now we build scsi_mod & sd_mod drivers as a modules
    !!!WARNING!!! look at your initrd for correct settings
  + Patches from Andrea
  + Added new SBNI driver from http://www.granch.ru/
  + Now we build emu10k1 tools in a package emu10k1-tools
- Fixed
  + emu10k1 patch
  + Buildrequires gcc || compat-gcc
  + NLS codepages for samba
- Updated
  + kernel to 2.4.6
  + ac-patch version to -ac2
  + bttv 0.7.69
  + hackalsa 0.9.0beta5
  + pcmcia_cs 3.1.27
  + emu10k1 to latest version
  + Intel ethernet drivers e100 & e1000
  + IPVS to 0.8.1

* Tue Jun 26 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.5-alt5
- Fixed
  + RSBAC patch in signal.c

* Sat Jun 16 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.5-alt4
- Added
  + Now we don't use and compile supermount with our kernels. We'll use
    autofs instead.
  + I2C patch ver 2.6.0
- Fixed
  + Removed HPT patch as it's not so stable for now
  + DRM arch check
  + <linux/capatibility.h> to compile samba
- Updated
  + ac-patch version to -ac15
  + lm-sensors to 2.6.0 version

* Thu Jun 14 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.5-alt3
- Fixed
  + Buildrequires
- Added
  + RSBAC rcsoftmode patch
  + HPT ide driver patch
  + VIA sound driver update patch
  + New serial mouse driver with /dev/input/mouse interface that allow increase update
    rate of mouse to higher values
  + ALI pci bus fix
  + MIRO Radio patch
  + i810_audio sound driver patch
  + Creative DXR2 DVD drivers
- Updated
  + ac-patch version to -ac13
  + International crypto patch to 2.4.3.1 version
  + ide patch temporary removed because it's in ac patch now
  + Now we don't compile crypto mars, idea & rc6 cyphers as they're not free
  + BTTV driver to 0.7.68 version
  + EMU10K1 driver to latest snapshot

* Tue Jun 5 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.5-alt2
- Added
  + Now we build DRM kernel modules within kernel
  + New package drm-source
- Updated
  + ac-patch version to -ac8
  + Enable sysrq option in configs

* Fri Jun 1 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.5-alt1
- Added
  + LIRC drivers 0.6.3 version
  + TPAM ISDN driver
- Fixed
  + Some CFLAGS for kernel
  + RSBAC rename
- Updated
  + Kernel version to 2.4.5
  + ac-patch version to -ac6
  + Emu10k1 driver to 20010528
  + ide patch to 05132001
  + Some kernel configs cleanup
  + Some Cooker pacthes
  + Freeswan to latest snapshot
  + SPEC cleanup

* Fri May 25 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.4-alt4
- Added
  + ISO9660_FS now build as module
- Fixed
  + Promise 20267 RAID (FastTrack 100) support with UDMA
  + Some RSBAC fixes (initrd)
- Updated
  + ac patch to 17
  + RSBAC to ver 1.1.2-pre4
  + BTTV driver to 0.7.67 ver.

* Wed May 16 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.4-alt3
- Fixed
  + ALT Linux logo to new kernel format
  + Supermount write to floppy bug
  + Tulip net driver
- Updated
  + ac patch to 9
  + ALSA drivers to 0.5.11
  + HackALSA drivers to 0.9.0beta4
  + Pcmcia_cs to 3.1.26 version

* Fri May 11 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.4-alt2
- Updated
  + ac patch to 6

* Wed May 8 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.4-alt1
- Added
  + ALT Linux logo for framebuffer
  + Now we build floppy & cd drivers as modules
  + Now 2.4.x serie kernels may be compiled with gcc 2.96, but we
    don't recommend it (this is required for AMD Athlon optimization)
  + Support for agp & ide DMA for VIA KT266 & APOLLO PRO 266 chipsets
- Fixed
  + RSBAC log
  + MAXIFM2 radio driver
  + fmx2 radio driver
  + usb logitech quickcam driver
  + Some gcc-2.96 fixes
  + Some promise ide raid controllers bugs
  + Shutting up some drives (ide cd, filesystems & parport) warnings printed to console
- Updated
  + Some patches
  + ac patch to 5
  + kernel version to 2.4.4
  + bttv driver
  + Emu10k1 driver to latest snapshot
  + ide patch

* Thu Apr 19 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.3-alt5
- Fixed
  + RSBAC ruid patch
  + Supermount

* Wed Apr 18 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.3-alt4
- Fixed
  + Some more fixes
  + RSBAC ruid patch
- Updated
  + ac patch to -9

* Thu Apr 17 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.3-alt3
- Added
  + New driver for Guillemot Maxi Radio FM 2 ISA
  + New patches from MandrakeSoft
- Fixed
  + Realtek 8139too bug (in ac-7 patch)
  + RSBAC ruid patch
  + Iptables bug
  + Some more fixes in patches
  + VIA PCI bug (in ac-7 patch)
- Updated
  + Updated ac patch to -7 version

* Thu Apr 12 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.3-alt2
- Added
  + New HackAlsa packages for advanced users & developers
- Fixed
  + Requires with alsa packages
  + RSBAC config
- Updated
  + Intel e100 & e1000 drivers
  + Updated ac patch to -4 version
  + SMP Configs to use 4Gb RAM
  + Realtek 8139too driver to cvs version

* Mon Apr 09 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.3-alt1
- Added
  + Rsbac configs & spec changes
  + Split secure to smp-secure & up-secure versions
- Updated
  + Kernel to 2.4.3 version
  + AC patch to ac-3
  + Freeswan to 1.9
  + BTTV to 0.7.62 version
  + emu10k1 to 0408 version
  + Updated ide drivers with Hedrick patch
- Fixed
  + Possibly bug in via ide driver
  + Kill all entries in changelog before 01.01.2001.

* Fri Mar 23 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.2-ipl6mdk
- Updated
  + AC patch to ac-22

* Tue Mar 20 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.2-ipl5mdk
- Added
  + Rename kernel24 to kernel24-up

* Fri Mar 16 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.2-ipl4mdk
- Added
  + Patch for iptools compatibility
  + Patches for freeswan
  + Patches for new aic7xxx driver
- Fixed
  + Some old patches
  + Configs
- Updated
  + Pcmcia_cs to ver 3.1.25
  + -ac patch ver 20
  + Creative emu10k1 to ver 0309
  + Freeswan snapshot

* Mon Mar 12 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.2-ipl3mdk
- Fixed
  + DRM sync fro XFree 4.0.2
  + Build with LANG=C

* Mon Mar 5 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.2-ipl2mdk
- Added:
  + New patches from Mandrake cooker
- Fixed:
  + Removed cp1251 patch. In kernel now.
- Updated:
  + Kernel 2.4.2 ac-patch 11
  + Freeswan to current snapshot
  + Pcmcia-cs to current snapshot

* Sat Feb 24 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.2-ipl1mdk
- Added:
  + Integrated updated emu10k1 driver from creative
  + New patches from Mandrake cooker
  + Config for k6
- Fixed:
  + Loop bug
  + Some other small fixes
- Updated:
  + Kernel 2.4.2
  + Kernel 2.4.2 ac-patch 3
  + Via82cxxx IDE driver

* Mon Feb 19 2001 Konstantin Volckov <goldhead@linux.ru.net> 2.4.1-ipl1mdk
- First build for MandrakeRE
- Added:
  + Freeswan last snapshot
  + International Crypto patch
  + Driver for SF16FMx2 radio cards
  + NLS cp1251 codepage support
  + IP Virtual Server patch
  + Spec file rewrited in Dmitry Levin's format
  + Configs for i586-smp, i686, i686-smp, athlon
- Fixed:
  + DRM drivers
  + Kernel initcall
  + i810 sound driver
  + Server tuning for some kernel definitions
  + Use KGCC compiler
  + Some other small fixes
- Updated:
  + Kernel 2.4.1 ac-patch 18
  + Alsa driver to 0.5.10b version
  + i586 config

* Tue Feb 13 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.1-10mdk
- 2.4.1.
- Oden Eriksson <oden.eriksson@kvikkjokk.net>:
	* added TechWell TW98 i2c driver support, patch 504.

* Sat Feb 10 2001 Stefan van der Eijk <s.vandereijk@chello.nl> 2.4.1-9mdk
- 2.4.1-ac8
- add patch for lm_sensors prob with perm.h (alpha)

* Fri Feb  9 2001 Stefan van der Eijk <s.vandereijk@chello.nl> 2.4.1-8mdk
- 2.4.1-ac7
- moved patch 362 into the pcmcia section

* Thu Feb  8 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 2.4.1-7mdk
- update alpha config

* Wed Feb  7 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.1-6mdk
- 2.4.1-ac6.

* Wed Feb  7 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.1-5mdk
- make oldconfig && make dep before shipping kernel-source.
- Upgrade loop patch from jens axboe.
- Add alternatives Lucen Wavelan wireless support.
- Fix bad udelay with wavelan.
- Add aacraid drivers.
- Raid force to use SSE xor block to be able to write around L2.
- Fix assertion of kiobuf to map to user.
- Fix IRDA assertion.
- Add e810 Acpi proc information (not activated by default since we
  don't use ACPI).
- Add e1000 drivers.
- Upgrade e100 drivers.
- Desactive Devfs.
- Add 3c90x drivers.
- 2.4.1-ac4.
- pcmcia-3.1.24.

* Mon Feb  5 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.1-4mdk
- Upgrade qlogic drivers to 2.19.15.
- Upgrade swap limit to 32.
- Upgrade megaraid drivers.
- Add intel100 network drivers.
- Upgrade ips.
- Upgrade idetape.
- Add new ids for es1371 cards.
- Add dpt_i2o support.
- Add dc395 update.

* Mon Feb  5 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.1-3mdk
- 2.4.1-ac3.

* Mon Feb  5 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.1-2mdk
- fix the version field.

* Mon Feb 05 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.1-1mdk.
- 2.4.1-ac2.

* Sun Jan 28 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-12mdk
- Add loop fixes from jens axboe.
- Add patch from rh (emu10k1 fixes, overflow check, noghighmemdebug,
  netfilter cpp fixes).

* Sat Jan 27 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 2.4.0-11mdk
- Update alpha config

* Sat Jan 27 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-10mdk
- 2.4.0-ac12.

* Thu Jan 25 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-9mdk
- Make pcmcia config files as noreplace.
- Upgrade ide-floppy for ac11 (author).
- Really apply LVM fixes.

* Wed Jan 24 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-8mdk
- LVM proc fixes from andrea

* Wed Jan 24 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-7mdk
- Alsa-0.5.10b.
- Remove reiserfs-utils.
- 2.4.0-ac11.

* Tue Jan 23 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-6mdk
- Add upgrade of ide-floppy drivers.
- Add rivatv lm_sensors support (oden).
- Add lm_sensors package in the source (and generate the patch from
  package) (oden)
- really integrating ksymoops-2.4.0 (oden.eriksson@kvikkjokk.net).
- Upgrade usb scanner.
- Remove all modules.*
- Add NFSv3 Patches.

* Mon Jan 15 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-5mdk
- Upgrade smctr from ac series to get the bad_udelay symbol fixed.
- Supermount upgrade.

* Fri Jan 12 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-4mdk
- Reorganise spec files.
- ksymoops-2.4.0.

* Fri Jan 12 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 2.4.0-3mdk
- Update alpha config

* Tue Jan  9 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-2mdk
- Pcmcia-3.1.23.
- Alsa-0.5.10a.

* Tue Jan 09 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.4.0-1mdk
- 2.4.0
- Reiserf 3.6.25
